#include <iostream>
#include <boost/shared_ptr.hpp>

using namespace std;
using namespace boost;

class AClass
{
public:
	void Op() const 
	{
		++i;
	}

	int Get() const
	{
		return i;
	}

private:
	mutable int i;
};

#ifdef SHARED_PTR
void Foo(const shared_ptr<AClass>& p)
{
	p->Op();
}
#elif defined(SHARED_PTR_COPY)
void Foo(shared_ptr<AClass> p)
{
	p->Op();
}
#else
void Foo(AClass* p)
{
	p->Op();
}
#endif

int
main(int argc, char* argv[])
{
#if defined(SHARED_PTR) || defined(SHARED_PTR_COPY)
	shared_ptr<AClass> p(new AClass());
#else
	AClass* p = new AClass();
#endif

	int maxCnt = 1000000000;
	if (argc >= 2)
		maxCnt = atoi(argv[1]);

	int i = 0;
	for (; i < maxCnt; ++i)
	{
#ifndef LOOP_TEST
		Foo(p);
#endif
	}

	cout << p->Get() << " " << i << endl;

	return 0;
}

